/*!
[config]
name: Test ushort rhadd built-in on CL 1.1
clc_version_min: 10
dimensions: 1
global_size: 1 0 0

[test]
name: rhadd ushort1
kernel_name: test_1_rhadd_ushort
arg_out: 0 buffer ushort[1] 33
arg_in: 1 buffer ushort[1] 32
arg_in: 2 buffer ushort[1] 33

[test]
name: rhadd ushort1
kernel_name: test_1_rhadd_ushort
arg_out: 0 buffer ushort[1] 1
arg_in: 1 buffer ushort[1] 1
arg_in: 2 buffer ushort[1] 0

[test]
name: rhadd ushort1
kernel_name: test_1_rhadd_ushort
arg_out: 0 buffer ushort[1] 10
arg_in: 1 buffer ushort[1] 12
arg_in: 2 buffer ushort[1] 8

[test]
name: rhadd ushort2
kernel_name: test_2_rhadd_ushort
arg_out: 0 buffer ushort[2] 33 33
arg_in: 1 buffer ushort[2] 32 32
arg_in: 2 buffer ushort[2] 33 33

[test]
name: rhadd ushort2
kernel_name: test_2_rhadd_ushort
arg_out: 0 buffer ushort[2] 1 1
arg_in: 1 buffer ushort[2] 1 1
arg_in: 2 buffer ushort[2] 0 0

[test]
name: rhadd ushort2
kernel_name: test_2_rhadd_ushort
arg_out: 0 buffer ushort[2] 10 10
arg_in: 1 buffer ushort[2] 12 12
arg_in: 2 buffer ushort[2] 8 8

[test]
name: rhadd ushort4
kernel_name: test_4_rhadd_ushort
arg_out: 0 buffer ushort[4] 33 33 33 33
arg_in: 1 buffer ushort[4] 32 32 32 32
arg_in: 2 buffer ushort[4] 33 33 33 33

[test]
name: rhadd ushort4
kernel_name: test_4_rhadd_ushort
arg_out: 0 buffer ushort[4] 1 1 1 1
arg_in: 1 buffer ushort[4] 1 1 1 1
arg_in: 2 buffer ushort[4] 0 0 0 0

[test]
name: rhadd ushort4
kernel_name: test_4_rhadd_ushort
arg_out: 0 buffer ushort[4] 10 10 10 10
arg_in: 1 buffer ushort[4] 12 12 12 12
arg_in: 2 buffer ushort[4] 8 8 8 8

[test]
name: rhadd ushort8
kernel_name: test_8_rhadd_ushort
arg_out: 0 buffer ushort[8] 33 33 33 33 33 33 33 33
arg_in: 1 buffer ushort[8] 32 32 32 32 32 32 32 32
arg_in: 2 buffer ushort[8] 33 33 33 33 33 33 33 33

[test]
name: rhadd ushort8
kernel_name: test_8_rhadd_ushort
arg_out: 0 buffer ushort[8] 1 1 1 1 1 1 1 1
arg_in: 1 buffer ushort[8] 1 1 1 1 1 1 1 1
arg_in: 2 buffer ushort[8] 0 0 0 0 0 0 0 0

[test]
name: rhadd ushort8
kernel_name: test_8_rhadd_ushort
arg_out: 0 buffer ushort[8] 10 10 10 10 10 10 10 10
arg_in: 1 buffer ushort[8] 12 12 12 12 12 12 12 12
arg_in: 2 buffer ushort[8] 8 8 8 8 8 8 8 8

[test]
name: rhadd ushort16
kernel_name: test_16_rhadd_ushort
arg_out: 0 buffer ushort[16] 33 33 33 33 33 33 33 33 33 33 33 33 33 33 33 33
arg_in: 1 buffer ushort[16] 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32
arg_in: 2 buffer ushort[16] 33 33 33 33 33 33 33 33 33 33 33 33 33 33 33 33

[test]
name: rhadd ushort16
kernel_name: test_16_rhadd_ushort
arg_out: 0 buffer ushort[16] 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
arg_in: 1 buffer ushort[16] 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
arg_in: 2 buffer ushort[16] 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0

[test]
name: rhadd ushort16
kernel_name: test_16_rhadd_ushort
arg_out: 0 buffer ushort[16] 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10 10
arg_in: 1 buffer ushort[16] 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12 12
arg_in: 2 buffer ushort[16] 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8 8

!*/

kernel void test_1_rhadd_ushort(global ushort* out, global ushort* in0, global ushort* in1){
  *out = rhadd(*in0, *in1);
}

kernel void test_2_rhadd_ushort(global ushort* out, global ushort* in0, global ushort* in1){
  vstore2(rhadd(vload2(0, in0), vload2(0, in1)), 0, out);
}

kernel void test_4_rhadd_ushort(global ushort* out, global ushort* in0, global ushort* in1){
  vstore4(rhadd(vload4(0, in0), vload4(0, in1)), 0, out);
}

kernel void test_8_rhadd_ushort(global ushort* out, global ushort* in0, global ushort* in1){
  vstore8(rhadd(vload8(0, in0), vload8(0, in1)), 0, out);
}

kernel void test_16_rhadd_ushort(global ushort* out, global ushort* in0, global ushort* in1){
  vstore16(rhadd(vload16(0, in0), vload16(0, in1)), 0, out);
}

